import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;

public class TextEncToSjis {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length != 0) {
			String infilepath = args[0];
			String outfilepath;
			FileInputStream fis = null;
			FileOutputStream fos = null;

			if (args.length == 1) {
				outfilepath = infilepath + ".fix";
			} else {
				outfilepath = args[1];
			}

			try {
				fis = new FileInputStream(infilepath);
				fos = new FileOutputStream(outfilepath);
				int readbyte1;

				while ((readbyte1 = fis.read()) != -1) {

					// \Εϊ
					if (readbyte1 == 0x5C) {
						int readbyte2 = fis.read();

						// \\̏ꍇ\
						if (readbyte2 == 0x5C) {
							fos.write(readbyte1);
						} else {
							char[] readchar1 = new char[2];
							readchar1[0] = (char) readbyte2;
							int readbyte3 = fis.read();
							readchar1[1] = (char) readbyte3;
							char[] readchar2 = new char[1];
							int readbyte4 = fis.read();
							readchar2[0] = (char) readbyte4;

							try {
								String outstring1 = new String(readchar1);
								int convint1 = Integer.valueOf(outstring1);
								String outstring2 = new String(readchar2);
								int convint2 = Integer.valueOf(outstring2);
								int writeint = outInt(convint1, convint2);
								fos.write(writeint);
							} catch (NumberFormatException e) {
								fos.write(readbyte1);
								fos.write(readbyte2);
								fos.write(readbyte3);
								fos.write(readbyte4);
							} catch (Exception e) {
								e.printStackTrace();
							}
						}
					} else {
						fos.write(readbyte1);
					}
				}
				System.out.println("Processing completion");

			} catch (FileNotFoundException e) {
				System.out
						.println("File is not found. or File is not possible to access.");
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				try {
					if (fis != null) {
						fis.close();
					}
					if (fos != null) {
						fos.close();
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}

		} else {
			System.out.println("Example)");
			System.out.println("java TextEncToSjis InputFile [OutputFile]");
		}
	}

	static int outInt(int inta, int intb) {
		int _outint = 0;
		String stringA = null;
		String stringB = null;
		if (inta == 20 || inta == 21) {
			stringA = "8";
		} else if (inta == 22 || inta == 23) {
			stringA = "9";
		} else if (inta == 24 || inta == 25) {
			stringA = "A";
		} else if (inta == 26 || inta == 27) {
			stringA = "B";
		} else if (inta == 30 || inta == 31) {
			stringA = "C";
		} else if (inta == 32 || inta == 33) {
			stringA = "D";
		} else if (inta == 34 || inta == 35) {
			stringA = "E";
		} else if (inta == 36 || inta == 37) {
			stringA = "F";
		}

		if ((inta % 2) == 1) {
			if (intb == 0) {
				stringB = "8";
			} else if (intb == 1) {
				stringB = "9";
			} else if (intb == 2) {
				stringB = "A";
			} else if (intb == 3) {
				stringB = "B";
			} else if (intb == 4) {
				stringB = "C";
			} else if (intb == 5) {
				stringB = "D";
			} else if (intb == 6) {
				stringB = "E";
			} else if (intb == 7) {
				stringB = "F";
			}
		} else {
			stringB = String.valueOf(intb);
		}
		String outstring = "0x" + stringA + stringB;
		_outint = Integer.decode(outstring).intValue();

		return _outint;
	}

}
